#ifndef TESTTENTUSSCHER_HPP
#define TESTTENTUSSCHER_HPP

#include "TestEnvironmentCardMech.hpp"

#include "MTenTusscher.hpp"
#include "MeshesCreator.hpp"
#include "LagrangeDiscretization.hpp"

auto eeReference = std::vector<double>{
    -86.2, -56.849296, 50.519236, 59.29736, 39.816965, 30.310236, 27.103971, 26.685289, 27.287072,
    28.182268, 29.127031, 30.057461, 30.959223, 31.824142, 32.641332, 33.398889, 34.0868, 34.698506,
    35.231119, 35.684916, 36.062588, 36.368479, 36.607954, 36.786897, 36.911345, 36.98723,
    37.020217, 37.015599, 36.978245, 36.912582, 36.822598, 36.711861, 36.583543, 36.440453,
    36.285069, 36.11957, 35.945867, 35.765633, 35.580328, 35.391225, 35.199429, 35.0059, 34.811469,
    34.616852, 34.422663, 34.229431, 34.037605, 33.847566, 33.659634, 33.474077, 33.291115,
    33.110929, 32.933662, 32.759427, 32.588307, 32.420364, 32.255637, 32.094145, 31.935894,
    31.780873, 31.629063, 31.480429, 31.334932, 31.192523, 31.053147, 30.916743, 30.783247,
    30.652589, 30.524699, 30.399502, 30.276922, 30.156882, 30.039306, 29.924113, 29.811226,
    29.700567, 29.592057, 29.48562, 29.381179, 29.27866, 29.177987, 29.079089, 28.981894, 28.886332,
    28.792336, 28.699838, 28.608774, 28.51908, 28.430696, 28.343561, 28.257619, 28.172812,
    28.089086, 28.00639, 27.924672, 27.843883, 27.763977, 27.684906, 27.606629, 27.529101,
    27.452282, 27.376133, 27.300617, 27.225696, 27.151337, 27.077506, 27.00417, 26.931299,
    26.858863, 26.786835, 26.715186, 26.643892, 26.572927, 26.502267, 26.431889, 26.361772,
    26.291895, 26.222238, 26.152782, 26.083508, 26.0144, 25.94544, 25.876612, 25.807901, 25.739293,
    25.670773, 25.602329, 25.533947, 25.465615, 25.397322, 25.329056, 25.260806, 25.192562,
    25.124315, 25.056054, 24.987772, 24.919458, 24.851104, 24.782704, 24.714247, 24.645729,
    24.57714, 24.508474, 24.439725, 24.370885, 24.301949, 24.232911, 24.163763, 24.094502,
    24.025121, 23.955615, 23.885978, 23.816205, 23.746292, 23.676233, 23.606023, 23.535657,
    23.465132, 23.394442, 23.323582, 23.252549, 23.181338, 23.109943, 23.038362, 22.966589,
    22.894621, 22.822452, 22.750079, 22.677498, 22.604703, 22.531692, 22.458458, 22.384999,
    22.31131, 22.237386, 22.163223, 22.088817, 22.014164, 21.939258, 21.864095, 21.788671,
    21.712982, 21.637022, 21.560786, 21.484271, 21.407471, 21.330381, 21.252996, 21.175312,
    21.097323, 21.019024, 20.94041, 20.861475, 20.782214, 20.702622, 20.622693, 20.542421, 20.4618,
    20.380825, 20.29949, 20.217788, 20.135713, 20.053259, 19.97042, 19.887188, 19.803558, 19.719522,
    19.635074, 19.550206, 19.464911, 19.379182, 19.293012, 19.206392, 19.119316, 19.031774,
    18.943759, 18.855263, 18.766277, 18.676793, 18.586802, 18.496295, 18.405262, 18.313695,
    18.221584, 18.128919, 18.035691, 17.941889, 17.847503, 17.752522, 17.656936, 17.560733,
    17.463903, 17.366434, 17.268314, 17.169531, 17.070073, 16.969927, 16.869082, 16.767522,
    16.665237, 16.56221, 16.45843, 16.353881, 16.248549, 16.142419, 16.035476, 15.927704, 15.819088,
    15.709611, 15.599256, 15.488007, 15.375845, 15.262754, 15.148715, 15.03371, 14.917719,
    14.800722, 14.682701, 14.563634, 14.443501, 14.322281, 14.199951, 14.076488, 13.951872,
    13.826077, 13.699079, 13.570856, 13.44138, 13.310627, 13.178571, 13.045183, 12.910438,
    12.774307, 12.63676, 12.497769, 12.357303, 12.215332, 12.071823, 11.926746, 11.780066, 11.63175,
    11.481763, 11.330071, 11.176636, 11.021423, 10.864393, 10.705509, 10.54473, 10.382018, 10.21733,
    10.050626, 9.8818618, 9.7109953, 9.537982, 9.3627769, 9.1853341, 9.0056072, 8.8235488,
    8.6391108, 8.4522444, 8.2629001, 8.0710278, 7.8765766, 7.6794953, 7.4797319, 7.2772341,
    7.071949, 6.8638237, 6.6528047, 6.4388384, 6.2218711, 6.0018491, 5.7787185, 5.5524258,
    5.3229177, 5.090141, 4.854043, 4.6145716, 4.3716748, 4.1253015, 3.8754009, 3.6219228, 3.3648176,
    3.104036, 2.8395289, 2.5712474, 2.2991424, 2.0231641, 1.7432621, 1.4593843, 1.1714768,
    0.87948286, 0.58334247, 0.28299113, -0.021640965, -0.33063008, -0.64406012, -0.96202391,
    -1.2846246, -1.6119772, -1.9442097, -2.2814653, -2.6239035, -2.9717018, -3.3250576, -3.6841896,
    -4.0493394, -4.4207735, -4.7987843, -5.1836923, -5.575847, -5.9756287, -6.3834497, -6.7997555,
    -7.2250263, -7.6597778, -8.1045619, -8.5599677, -9.0266221, -9.5051897, -9.9963727, -10.500911,
    -11.01958, -11.553192, -12.10259, -12.66865, -13.252272, -13.854383, -14.475928, -15.117864,
    -15.781159, -16.466782, -17.175699, -17.908867, -18.667231, -19.451717, -20.263233, -21.102672,
    -21.970909, -22.868815, -23.797269, -24.75717, -25.749462, -26.775164, -27.835399, -28.93144,
    -30.06475, -31.237044, -32.450346, -33.707055, -35.010028, -36.362657, -37.768958, -39.233659,
    -40.762285, -42.361212, -44.037687, -45.799744, -47.65596, -49.614921, -51.68423, -53.868821,
    -56.16834, -58.573592, -61.062622, -63.597956, -66.12716, -68.588271, -70.919317, -73.068567,
    -75.001635, -76.703582, -78.17659, -79.435169, -80.500836, -81.397619, -82.149006, -82.776309,
    -83.298105, -83.730325, -84.086615, -84.378743, -84.616932, -84.81009, -84.965958, -85.09121,
    -85.191535, -85.27172, -85.335743, -85.386871, -85.427759, -85.460545, -85.48694, -85.508304,
    -85.525714, -85.540019, -85.551888, -85.561846, -85.570305, -85.577586, -85.583943, -85.589573,
    -85.59463, -85.599237, -85.603488, -85.607457, -85.611203, -85.614771, -85.618197, -85.621508,
    -85.624728, -85.627872, -85.630955, -85.633987, -85.636976, -85.63993, -85.642852, -85.645748,
    -85.648619, -85.651469, -85.654299, -85.657111, -85.659906, -85.662684, -85.665447, -85.668195,
    -85.670928, -85.673647, -85.676351, -85.679041, -85.681717, -85.684378, -85.687026, -85.689659,
    -85.692278, -85.694883, -85.697474, -85.700051, -85.702613, -85.705161, -85.707694, -85.710213,
    -85.712718, -85.715208, -85.717684, -85.720144, -85.722591, -85.725022, -85.727439, -85.729841,
    -85.732229, -85.734601, -85.736959, -85.739302, -85.741631, -85.743944, -85.746243, -85.748527,
    -85.750796, -85.753051, -85.755291, -85.757516, -85.759727, -85.761923, -85.764104, -85.766271,
    -85.768423, -85.77056, -85.772684, -85.774792, -85.776887, -85.778967, -85.781033, -85.783084,
    -85.785122, -85.787145, -85.789154, -85.791149, -85.79313, -85.795097, -85.797051, -85.798991,
    -85.800916, -85.802829, -85.804727, -85.806613, -85.808484, -85.810343, -85.812188, -85.81402,
    -85.815838, -85.817644, -85.819436, -85.821216, -85.822983, -85.824737, -85.826478, -85.828207,
    -85.829923, -85.831626, -85.833317, -85.834996, -85.836663, -85.838317, -85.839959, -85.84159,
    -85.843208, -85.844815, -85.846409, -85.847992, -85.849564, -85.851124, -85.852672, -85.854209,
    -85.855735, -85.857249, -85.858753, -85.860245, -85.861727, -85.863197, -85.864657, -85.866106,
    -85.867544, -85.868971, -85.870389, -85.871795, -85.873192, -85.874578, -85.875953, -85.877319,
    -85.878675, -85.880021, -85.881356, -85.882682, -85.883999, -85.885305, -85.886602, -85.887889,
    -85.889167, -85.890436, -85.891695, -85.892945, -85.894186, -85.895418, -85.896641, -85.897855,
    -85.89906, -85.900256, -85.901443, -85.902622, -85.903792, -85.904953, -85.906106, -85.907251,
    -85.908388, -85.909516, -85.910635, -85.911747, -85.912851, -85.913946, -85.915034};

auto rk2Reference = std::vector<double>{
    -86.2, -56.845931, 50.410649, 59.235523, 39.768835, 30.287859, 27.092513, 26.676683, 27.278374,
    28.172698, 29.116627, 30.04645, 30.947821, 31.812517, 32.629615, 33.387184, 34.075193,
    34.687063, 35.219892, 35.673944, 36.051895, 36.358079, 36.597855, 36.777098, 36.901841,
    36.978015, 37.01128, 37.006931, 36.969834, 36.904419, 36.814672, 36.704162, 36.576062,
    36.433182, 36.278, 36.112696, 35.939181, 35.759129, 35.574001, 35.385069, 35.193441, 35.000075,
    34.805802, 34.61134, 34.417303, 34.224219, 34.032537, 33.842639, 33.654846, 33.469424,
    33.286594, 33.106537, 32.929397, 32.755285, 32.584287, 32.416462, 32.251849, 32.09047,
    31.932329, 31.777416, 31.62571, 31.477178, 31.331781, 31.189468, 31.050187, 30.913875,
    30.780468, 30.649897, 30.522092, 30.396977, 30.274477, 30.154515, 30.037014, 29.921895,
    29.809079, 29.698489, 29.590047, 29.483675, 29.379298, 29.276839, 29.176226, 29.077386,
    28.980247, 28.88474, 28.790796, 28.698349, 28.607334, 28.517689, 28.429351, 28.342262,
    28.256363, 28.171598, 28.087914, 28.005258, 27.923578, 27.842827, 27.762957, 27.683922,
    27.605678, 27.528183, 27.451397, 27.375279, 27.299793, 27.224902, 27.150571, 27.076768,
    27.003459, 26.930614, 26.858204, 26.7862, 26.714576, 26.643305, 26.572362, 26.501724, 26.431368,
    26.361272, 26.291416, 26.221778, 26.152342, 26.083087, 26.013997, 25.945054, 25.876244,
    25.80755, 25.738959, 25.670456, 25.602027, 25.533661, 25.465344, 25.397066, 25.328814,
    25.260579, 25.192349, 25.124115, 25.055868, 24.987599, 24.919298, 24.850957, 24.782569,
    24.714125, 24.645618, 24.577041, 24.508387, 24.439649, 24.370821, 24.301896, 24.232868,
    24.163731, 24.094481, 24.02511, 23.955614, 23.885987, 23.816224, 23.746321, 23.676271,
    23.606071, 23.535715, 23.465199, 23.394518, 23.323668, 23.252644, 23.181441, 23.110056,
    23.038484, 22.96672, 22.89476, 22.8226, 22.750235, 22.677662, 22.604876, 22.531873, 22.458648,
    22.385197, 22.311516, 22.2376, 22.163445, 22.089047, 22.014402, 21.939504, 21.864349, 21.788933,
    21.713251, 21.637299, 21.561071, 21.484564, 21.407771, 21.330689, 21.253312, 21.175636,
    21.097655, 21.019363, 20.940757, 20.86183, 20.782577, 20.702992, 20.623071, 20.542807,
    20.462194, 20.381226, 20.299899, 20.218205, 20.136138, 20.053692, 19.97086, 19.887636,
    19.804014, 19.719986, 19.635546, 19.550686, 19.465399, 19.379678, 19.293516, 19.206904,
    19.119836, 19.032302, 18.944296, 18.855808, 18.766831, 18.677355, 18.587372, 18.496874,
    18.40585, 18.314291, 18.222189, 18.129533, 18.036314, 17.942521, 17.848144, 17.753172,
    17.657595, 17.561402, 17.464581, 17.367122, 17.269011, 17.170238, 17.07079, 16.970655,
    16.869819, 16.76827, 16.665994, 16.562979, 16.459209, 16.354671, 16.24935, 16.143231, 16.036299,
    15.928538, 15.819933, 15.710468, 15.600125, 15.488887, 15.376738, 15.263659, 15.149633,
    15.03464, 14.918662, 14.801678, 14.68367, 14.564617, 14.444498, 14.323291, 14.200975, 14.077527,
    13.952925, 13.827144, 13.700162, 13.571954, 13.442494, 13.311757, 13.179716, 13.046345,
    12.911617, 12.775502, 12.637973, 12.499, 12.358552, 12.216599, 12.073109, 11.92805, 11.78139,
    11.633093, 11.483127, 11.331454, 11.178041, 11.022849, 10.865841, 10.706979, 10.546223,
    10.383533, 10.218869, 10.052188, 9.8834488, 9.7126072, 9.5396193, 9.3644401, 9.1870237,
    9.0073238, 8.8252929, 8.640883, 8.4540452, 8.2647301, 8.0728876, 7.8784668, 7.6814165,
    7.4816848, 7.2792192, 7.0739671, 6.8658754, 6.6548906, 6.4409592, 6.2240275, 6.0040417,
    5.780948, 5.554693, 5.3252232, 5.0924855, 4.8564273, 4.6169963, 4.3741406, 4.1278092, 3.8779511,
    3.6245164, 3.3674552, 3.1067183, 2.8422567, 2.5740214, 2.3019634, 2.0260328, 1.7461793,
    1.4623508, 1.1744935, 0.88255063, 0.58646222, 0.28616385, -0.018414225, -0.32734819,
    -0.64072185, -0.95862795, -1.2811695, -1.6084613, -1.9406314, -2.2778226, -2.6201943,
    -2.9679239, -3.3212083, -3.6802662, -4.0453389, -4.4166925, -4.7946193, -5.1794393, -5.5715018,
    -5.9711866, -6.3789057, -6.7951043, -7.2202621, -7.6548943, -8.0995526, -8.5548255, -9.0213396,
    -9.4997588, -9.9907852, -10.495158, -11.013653, -11.54708, -12.096283, -12.662138, -13.245545,
    -13.847429, -14.468736, -15.110423, -15.773457, -16.458808, -17.167441, -17.900314, -18.658371,
    -19.442539, -20.253727, -21.092826, -21.960713, -22.858259, -23.786341, -24.74586, -25.737759,
    -26.763055, -27.82287, -28.918476, -30.051333, -31.223154, -32.435957, -33.692139, -34.994552,
    -36.346579, -37.752231, -39.216229, -40.744085, -42.342169, -44.017718, -45.778759, -47.633865,
    -49.591629, -51.659671, -53.842968, -56.141243, -58.545419, -61.033699, -63.568784, -66.098383,
    -68.560591, -70.893382, -73.044869, -74.98046, -76.685008, -78.160531, -79.42143, -80.489166,
    -81.387757, -82.140703, -82.769344, -83.292286, -83.725487, -84.082614, -84.375454, -84.614245,
    -84.807907, -84.964194, -85.089792, -85.190399, -85.270814, -85.335022, -85.386299, -85.427306,
    -85.460186, -85.486656, -85.50808, -85.525536, -85.539879, -85.551777, -85.561758, -85.570235,
    -85.57753, -85.583898, -85.589537, -85.594601, -85.599214, -85.603469, -85.607441, -85.611189,
    -85.614759, -85.618186, -85.621499, -85.624719, -85.627864, -85.630947, -85.63398, -85.636969,
    -85.639923, -85.642845, -85.64574, -85.648612, -85.651461, -85.654291, -85.657103, -85.659898,
    -85.662676, -85.665439, -85.668187, -85.67092, -85.673638, -85.676342, -85.679032, -85.681707,
    -85.684369, -85.687016, -85.689649, -85.692268, -85.694873, -85.697464, -85.70004, -85.702602,
    -85.70515, -85.707683, -85.710202, -85.712707, -85.715197, -85.717672, -85.720133, -85.722579,
    -85.72501, -85.727427, -85.729829, -85.732217, -85.734589, -85.736947, -85.73929, -85.741618,
    -85.743932, -85.746231, -85.748515, -85.750784, -85.753039, -85.755278, -85.757504, -85.759714,
    -85.76191, -85.764091, -85.766258, -85.76841, -85.770548, -85.772671, -85.77478, -85.776874,
    -85.778954, -85.78102, -85.783071, -85.785109, -85.787132, -85.789141, -85.791136, -85.793117,
    -85.795085, -85.797038, -85.798978, -85.800904, -85.802816, -85.804715, -85.8066, -85.808472,
    -85.81033, -85.812175, -85.814007, -85.815826, -85.817631, -85.819424, -85.821203, -85.82297,
    -85.824724, -85.826465, -85.828194, -85.82991, -85.831614, -85.833305, -85.834984, -85.83665,
    -85.838305, -85.839947, -85.841578, -85.843196, -85.844803, -85.846397, -85.84798, -85.849552,
    -85.851112, -85.85266, -85.854197, -85.855723, -85.857238, -85.858741, -85.860234, -85.861715,
    -85.863185, -85.864645, -85.866094, -85.867532, -85.86896, -85.870377, -85.871784, -85.87318,
    -85.874566, -85.875942, -85.877308, -85.878664, -85.88001, -85.881345, -85.882671, -85.883988,
    -85.885294, -85.886591, -85.887879, -85.889157, -85.890425, -85.891685, -85.892935, -85.894176,
    -85.895408, -85.89663, -85.897844, -85.899049, -85.900245, -85.901433, -85.902612, -85.903782,
    -85.904943, -85.906097, -85.907241, -85.908378, -85.909506, -85.910626, -85.911737, -85.912841,
    -85.913937, -85.915024};

auto rk4Reference = std::vector<double>{
    -86.2, -56.845926, 50.410804, 59.235614, 39.772324, 30.289952, 27.09378, 26.67757, 27.279119,
    28.17341, 29.117349, 30.04719, 30.948576, 31.813281, 32.63038, 33.387944, 34.075942, 34.687797,
    35.220608, 35.674641, 36.052571, 36.358735, 36.59849, 36.777713, 36.902437, 36.978592, 37.01184,
    37.007473, 36.970361, 36.90493, 36.815169, 36.704645, 36.576532, 36.43364, 36.278445, 36.113129,
    35.939603, 35.759541, 35.574402, 35.38546, 35.193821, 35.000446, 34.806164, 34.611692,
    34.417645, 34.224553, 34.032862, 33.842956, 33.655154, 33.469723, 33.286886, 33.106821,
    32.929673, 32.755554, 32.584548, 32.416716, 32.252096, 32.09071, 31.932562, 31.777642, 31.62593,
    31.477392, 31.331988, 31.18967, 31.050383, 30.914065, 30.780652, 30.650077, 30.522266,
    30.397146, 30.274641, 30.154674, 30.037168, 29.922045, 29.809225, 29.69863, 29.590183,
    29.483808, 29.379426, 29.276964, 29.176347, 29.077503, 28.980361, 28.88485, 28.790903,
    28.698453, 28.607435, 28.517787, 28.429446, 28.342354, 28.256452, 28.171685, 28.087998,
    28.005339, 27.923657, 27.842904, 27.763031, 27.683994, 27.605748, 27.528251, 27.451462,
    27.375343, 27.299855, 27.224962, 27.15063, 27.076824, 27.003514, 26.930667, 26.858255, 26.78625,
    26.714624, 26.643351, 26.572407, 26.501768, 26.431411, 26.361314, 26.291456, 26.221817,
    26.152379, 26.083123, 26.014032, 25.945089, 25.876277, 25.807583, 25.73899, 25.670486,
    25.602056, 25.533689, 25.465371, 25.397092, 25.32884, 25.260603, 25.192373, 25.124138, 25.05589,
    24.98762, 24.919318, 24.850977, 24.782588, 24.714143, 24.645636, 24.577058, 24.508403,
    24.439664, 24.370835, 24.30191, 24.232881, 24.163744, 24.094493, 24.025122, 23.955625,
    23.885998, 23.816234, 23.74633, 23.67628, 23.606079, 23.535723, 23.465207, 23.394525, 23.323674,
    23.25265, 23.181447, 23.110061, 23.038488, 22.966723, 22.894763, 22.822603, 22.750238,
    22.677664, 22.604878, 22.531874, 22.458648, 22.385197, 22.311515, 22.237599, 22.163444,
    22.089046, 22.0144, 21.939501, 21.864346, 21.78893, 21.713248, 21.637295, 21.561067, 21.484559,
    21.407766, 21.330684, 21.253306, 21.175629, 21.097648, 21.019356, 20.940749, 20.861822,
    20.782568, 20.702984, 20.623062, 20.542797, 20.462184, 20.381216, 20.299888, 20.218194,
    20.136126, 20.05368, 19.970848, 19.887624, 19.804001, 19.719973, 19.635532, 19.550672,
    19.465385, 19.379664, 19.293501, 19.206889, 19.11982, 19.032286, 18.944279, 18.855791,
    18.766813, 18.677337, 18.587354, 18.496855, 18.405831, 18.314272, 18.22217, 18.129513,
    18.036294, 17.9425, 17.848123, 17.753151, 17.657573, 17.56138, 17.464559, 17.367098, 17.268987,
    17.170214, 17.070765, 16.970629, 16.869793, 16.768244, 16.665968, 16.562952, 16.459182,
    16.354643, 16.249321, 16.143202, 16.03627, 15.928509, 15.819903, 15.710437, 15.600093,
    15.488856, 15.376706, 15.263627, 15.1496, 15.034606, 14.918627, 14.801644, 14.683635, 14.564581,
    14.444461, 14.323254, 14.200937, 14.077489, 13.952886, 13.827105, 13.700122, 13.571913,
    13.442453, 13.311715, 13.179674, 13.046302, 12.911573, 12.775458, 12.637928, 12.498953,
    12.358505, 12.216551, 12.073061, 11.928001, 11.78134, 11.633042, 11.483075, 11.331402,
    11.177988, 11.022795, 10.865786, 10.706923, 10.546166, 10.383475, 10.21881, 10.052128, 9.883388,
    9.7125454, 9.5395565, 9.3643762, 9.1869588, 9.0072578, 8.8252257, 8.6408146, 8.4539757,
    8.2646595, 8.0728157, 7.8783937, 7.6813421, 7.4816091, 7.2791422, 7.0738888, 6.8657957,
    6.6548095, 6.4408767, 6.2239435, 6.0039562, 5.7808611, 5.5546045, 5.3251331, 5.0923939,
    4.8563341, 4.6169014, 4.3740441, 4.1277109, 3.8778511, 3.6244146, 3.3673517, 3.106613,
    2.8421495, 2.5739124, 2.3018524, 2.0259199, 1.7460644, 1.4622339, 1.1743746, 0.88242963,
    0.58633912, 0.2860386, -0.018541661, -0.32747786, -0.64085381, -0.95876224, -1.2813062,
    -1.6086005, -1.9407731, -2.2779669, -2.6203413, -2.9680736, -3.321361, -3.6804219, -4.0454977,
    -4.4168546, -4.7947849, -5.1796085, -5.5716747, -5.9713634, -6.3790867, -6.7952897, -7.2204522,
    -7.6550893, -8.0997528, -8.5550312, -9.0215511, -9.4999765, -9.9910094, -10.495389, -11.013891,
    -11.547326, -12.096538, -12.662401, -13.245817, -13.847711, -14.469028, -15.110725, -15.77377,
    -16.459132, -17.167777, -17.900663, -18.658733, -19.442915, -20.254117, -21.09323, -21.961132,
    -22.858694, -23.786793, -24.746328, -25.738243, -26.763557, -27.823391, -28.919015, -30.051892,
    -31.223733, -32.436558, -33.692764, -34.9952, -36.347254, -37.752935, -39.216963, -40.744854,
    -42.342975, -44.018565, -45.779651, -47.634806, -49.592623, -51.660722, -53.844077, -56.142408,
    -58.546632, -61.034947, -63.570043, -66.099624, -68.561783, -70.894496, -73.045883, -74.981362,
    -76.685795, -78.161207, -79.422004, -80.48965, -81.388162, -82.141042, -82.769626, -83.29252,
    -83.72568, -84.082772, -84.375583, -84.614349, -84.807991, -84.964261, -85.089845, -85.190442,
    -85.270848, -85.335049, -85.38632, -85.427322, -85.460199, -85.486666, -85.508087, -85.525543,
    -85.539884, -85.551781, -85.561761, -85.570237, -85.577532, -85.5839, -85.589538, -85.594602,
    -85.599214, -85.603469, -85.607442, -85.61119, -85.61476, -85.618187, -85.621499, -85.624719,
    -85.627864, -85.630947, -85.63398, -85.636969, -85.639923, -85.642845, -85.645741, -85.648612,
    -85.651462, -85.654292, -85.657103, -85.659898, -85.662677, -85.665439, -85.668187, -85.67092,
    -85.673638, -85.676342, -85.679032, -85.681707, -85.684369, -85.687016, -85.689649, -85.692269,
    -85.694873, -85.697464, -85.700041, -85.702603, -85.705151, -85.707684, -85.710203, -85.712707,
    -85.715197, -85.717673, -85.720133, -85.722579, -85.725011, -85.727428, -85.72983, -85.732217,
    -85.73459, -85.736947, -85.739291, -85.741619, -85.743932, -85.746231, -85.748515, -85.750784,
    -85.753039, -85.755279, -85.757504, -85.759715, -85.76191, -85.764092, -85.766258, -85.768411,
    -85.770548, -85.772671, -85.77478, -85.776875, -85.778955, -85.78102, -85.783072, -85.785109,
    -85.787133, -85.789142, -85.791137, -85.793118, -85.795085, -85.797039, -85.798978, -85.800904,
    -85.802817, -85.804715, -85.8066, -85.808472, -85.810331, -85.812176, -85.814007, -85.815826,
    -85.817632, -85.819424, -85.821204, -85.822971, -85.824725, -85.826466, -85.828195, -85.829911,
    -85.831614, -85.833305, -85.834984, -85.836651, -85.838305, -85.839948, -85.841578, -85.843196,
    -85.844803, -85.846398, -85.847981, -85.849552, -85.851112, -85.852661, -85.854198, -85.855724,
    -85.857238, -85.858742, -85.860234, -85.861715, -85.863186, -85.864646, -85.866095, -85.867533,
    -85.868961, -85.870378, -85.871784, -85.873181, -85.874567, -85.875943, -85.877309, -85.878664,
    -85.88001, -85.881346, -85.882672, -85.883988, -85.885295, -85.886592, -85.887879, -85.889157,
    -85.890426, -85.891685, -85.892935, -85.894176, -85.895408, -85.896631, -85.897845, -85.89905,
    -85.900246, -85.901433, -85.902612, -85.903782, -85.904944, -85.906097, -85.907242, -85.908378,
    -85.909506, -85.910626, -85.911738, -85.912842, -85.913937, -85.915025};


class MTenTusscherTest : public Test {
protected:
  std::unique_ptr<MElphyModel> cellModel;
  std::unique_ptr<MElphySolver> cellSolver;
  std::unique_ptr<Vector> dummyData;

  int powerTwoSteps(int n) {
    return (int) (pow(2, n) + 1e-4);
  }

  void printPythonVector(const std::string &name, const std::vector<std::vector<double>> vec,
                         int index = 0, int step = 1) {
    mout << name << " = [" << vec[0][index];
    for (int i = step; i < vec.size(); i += step) {
      mout << ", " << vec[i][index];
    }
    mout << "]" << endl;
  }

  void
  FillODESolution(TimeSeries &TS, std::vector<double> &t, std::vector<std::vector<double>> &v) {
    t.emplace_back(TS.CurrentTStep());
    for (int step = 0; step < TS.Steps(); ++step) {
      t.emplace_back(TS.NextTimeStep());
    }
    TS.Reset();
    cellSolver->Solve(TS, v);
  }


public:
  MTenTusscherTest() {
    cellModel = std::make_unique<MTenTusscher>();

    auto meshes = MeshesCreator().
        WithMeshName("Interval").
        WithCellData(DataContainer({1, 0, 0, 0, 1, 0, 0, 0, 1})).
        WithVertexData(DataContainer({0.0, 0.002, 1.0})).
        CreateUnique();
    auto disc = LagrangeDiscretization(*meshes, 1);
    dummyData = std::make_unique<Vector>(0.0, disc);
  }

  virtual ~MTenTusscherTest() = default;
};

#endif //TESTTENTUSSCHER_HPP
